#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define x first
#define y second

using namespace std;

typedef long long ll;
typedef vector < ll > vll;
typedef pair<ll,ll> pll;

vector < vector < char > > a;
vector < vector < bool > > used;
vector < vll > d;
vector < vector < pll > > path;

ll m, n;

pll bfs(ll f, ll s)
{
    queue<pll> q;
    q.push(mp(f,s));
    d[f][s] = 0;
    used[f][s] = 1;

    while(!q.empty())
    {
        pll p = q.front(); q.pop();

        if(!used[p.x-1][p.y])
        {
            used[p.x-1][p.y] = 1;
            d[p.x-1][p.y] = d[p.x][p.y] + 1;
            path[p.x-1][p.y] = p;
            if(p.x==1) return mp(p.x-1,p.y);
            q.push(mp(p.x-1,p.y));
        }

        if(!used[p.x+1][p.y])
        {
            used[p.x+1][p.y] = 1;
            d[p.x+1][p.y] = d[p.x][p.y] + 1;
            path[p.x+1][p.y] = p;
            if(p.x==m-2) return mp(p.x+1,p.y);
            q.push(mp(p.x+1,p.y));
        }

        if(!used[p.x][p.y-1])
        {
            used[p.x][p.y-1] = 1;
            d[p.x][p.y-1] = d[p.x][p.y] + 1;
            path[p.x][p.y-1] = p;
            if(p.y==1) return mp(p.x,p.y-1);
            q.push(mp(p.x,p.y-1));
        }

        if(!used[p.x][p.y+1])
        {
            used[p.x][p.y+1] = 1;
            d[p.x][p.y+1] = d[p.x][p.y] + 1;
            path[p.x][p.y+1] = p;
            if(p.y==n-2) return mp(p.x,p.y+1);
            q.push(mp(p.x,p.y+1));
        }
    }

    return mp(-1,-1);
}

int main()
{
    freopen("labirint.in","r",stdin);
    freopen("labirint.out","w",stdout);

    ll fir, sec;
    cin >> m >> n;

    a.resize(m);
    string s;
    cin.ignore();
    for(ll i = 0; i<m; i++)
    {
        getline(cin,s);
        while(s.size()<n) s = s + ' ';

        for(ll j = 0; j<n; j++) { a[i].pb(s[j]); if(s[j]=='+') { fir = i; sec = j; } }
    }

    if(fir==0 || fir == m-1 || sec==0 || sec == n-1) { cout << 0 << '\n'; return 0; }

    used.resize(m); d.resize(m); path.resize(m);
    for(ll i = 0; i<m; i++)
    {
        d[i].resize(n,-1); path[i].resize(n);
        for(ll j = 0; j<n; j++) if(a[i][j]!=' ') used[i].pb(1); else used[i].pb(0);
    }

    pll p = bfs(fir,sec);

    if(p.x==-1) { cout << -1 << '\n'; return 0; }
    cout << d[p.x][p.y] << '\n';

    string ans = "";
    ll l = p.x, r = p.y;

    for(ll i = 0; i<d[p.x][p.y]; i++)
    {
        ll l0 = path[l][r].x, r0 = path[l][r].y;

        if(l0 == l-1) ans = ans + 's';
        if(l0 == l+1) ans = ans + 'n';
        if(r0 == r-1) ans = ans + 'e';
        if(r0 == r+1) ans = ans + 'w';

        l = l0; r = r0;
    }
    reverse(ans.begin(),ans.end());

    cout << ans << '\n';
}
