#include<bits/stdc++.h>

using namespace std;

typedef vector<int> big;
const int base = 1e4;

int gcd(int a, int b, int &x, int &y) {
    if(a == 0) {
        x = 0;
        y = 1;
        return b;
    }
    int g = gcd(b % a, a, y, x);
    x -= (b/a) * y;
    return g;
}
void pris(big &a, int b) {
    a.clear();
    if(b == 0)
        a = big(1, 0);
    while(b) {
        a.push_back(b % base);
        b /= base;
    }
}
bool operator==(big &a, int b) {
    if(b == base && a.size() == 2 && a[0] == 0 && a[1] == 1)
        return true;
    if(a.size() > 1)
        return false;
    return a.back() == b;
}
bool operator!=(big &a, int b) {
    return !(a == b);
}
big operator-(big a, int b) {
    int saved = b;
    for(int i = 0;saved;++i) {
        saved = a[i] - saved;
        a[i] = (saved % base + base) % base;
        if(saved < 0)
            saved = (-saved + base - 1) / base;
        else
            saved = 0;
    }
    while(a.size() > 1 && a.back() == 0) a.pop_back();
    return a;
}
int operator%(big a, int b) {
    int saved = 0;
    for(int i = a.size()-1;i >= 0;--i)
        saved = (saved * base + a[i]) % b;
    return saved;
}
big operator/(big a, int b) {
    int saved = 0;
    for(int i = a.size()-1;i >= 0;--i) {
        saved = (saved * base + a[i]) % b;
        a[i] = saved / base;
        saved %= base;
    }
    while(a.size() > 1 && a.back() == 0) a.pop_back();
    return a;
}
big operator*(big a, int b) {
    int saved = 0;
    for(int i = 0;i < a.size() || saved;++i) {
        if(i == a.size())
            a.push_back(0);
        saved += a[i] *  b;
        a[i] = saved % base;
        saved /= base;
    }
    while(a.size() > 1 && a.back() == 0) a.pop_back();
    return a;
}
big operator+(big a, big b) {
    int saved = 0;
    for(int i = 0;i < b.size() || saved;++i) {
        if(i == a.size())
            a.push_back(0);
        saved += a[i];
        if(i < b.size())
            saved += b[i];
        a[i] = saved % base;
        saved /= base;
    }
    while(a.size() > 1 && a.back() == 0) a.pop_back();
    return a;
}
int main() {
    freopen("common.in", "r", stdin);
    freopen("common.out", "w", stdout);

    int n;
    cin >> n;
    big a, b;
    int c, d, x, y, g;

    vector<pair<int, int> > arr(n);
    for(int i = 0;i < n;++i)
        scanf("%d%d", &arr[i].first, &arr[i].second);
    sort(arr.begin(), arr.end(), greater<pair<int, int> >());

    pris(a, arr[0].first);
    pris(b, arr[0].second);

    for(int i = 1;i < n;++i) {
        c = arr[i].first;
        d = arr[i].second;
        if(b == 0 && d == 0) {
            if(a == c)
                continue;
            else {
                cout << "0\n";
                return 0;
            }
        }
        if(b == 0) {
            if((a - c) % d != 0) {
                cout << "0\n";
                return 0;
            }
            continue;
        }
        if(d == 0) {
            if(a != c) {
                cout << "0\n";
                return 0;
            }
            pris(a, c);
            b = big(1, 0);
            continue;
        }
        g = gcd(b % d, d, x, y);
//        cout << b%d << '*' << y << '+' << d << '*' << x << '\n';
//        x -= ((b / d) * y).back();
//        y *= -1;
        //cout << x << ' ' << y << '\n';
        if(a == c) {
            b = b * (d/g);
            continue;
        }
        if((a - c) % g != 0) {
            cout << "0\n";
            return 0;
        }
        x *= ((a - c) / g) % (d/g);
        x %= d/g;
        if(x < 0)
            x += (d/g) * ((-x * g + d - 1) / d);
        a = a + b * x;
        b = b * (d/g);
    }

    printf("%d", a.back());
    for(int i = a.size()-2;i >= 0;--i)
        printf("%04d", a[i]);
	cout << '\n';
    return 0;
}

//(b - (b / a) * a) * x1 + a * y1 = g;
//b * x1 + a * (y1 - b/a * x1);
//x = y1 - b/a * x1;
//y = x1;
/*4
3 1
5 3
8 2
8 6
*/
