/* GCC */
#include <bits/stdc++.h>

using namespace std;

#define qf q.front()
struct pt{
    int y, x;
};

bool operator ==(pt a, pt b){
    return a.x == b.x && a.y == b.y;
}

pt bfs(vector<vector<int> >& maze, vector<vector<char> >& result, pt start){
    queue<pt> q;
    q.push(start);
    while(!q.empty()){
        if(qf.x == 0 || qf.y == 0 || qf.x == maze[0].size() - 1 || qf.y == maze.size() - 1)
            return qf;
        if(maze[qf.y + 1][qf.x] == 0){
            maze[qf.y + 1][qf.x] = maze[qf.y][qf.x] + 1;
            result[qf.y + 1][qf.x] = 's';
            q.push({qf.y + 1, qf.x});
        }
        if(maze[qf.y - 1][qf.x] == 0){
            maze[qf.y - 1][qf.x] = maze[qf.y][qf.x] + 1;
            result[qf.y - 1][qf.x] = 'n';
            q.push({qf.y - 1, qf.x});
        }
        if(maze[qf.y][qf.x + 1] == 0){
            maze[qf.y][qf.x + 1] = maze[qf.y][qf.x] + 1;
            result[qf.y][qf.x + 1] = 'e';
            q.push({qf.y, qf.x + 1});
        }
        if(maze[qf.y][qf.x - 1] == 0){
            maze[qf.y][qf.x - 1] = maze[qf.y][qf.x] + 1;
            result[qf.y][qf.x - 1] = 'w';
            q.push({qf.y, qf.x - 1});
        }
        q.pop();
    }
    return {-1, -1};
}


int main(){
    freopen("labirint.in", "r", stdin);
    freopen("labirint.out", "w", stdout);
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);
    pt startpos, endpos;
    int N, M;
    string temp;
    cin >> N >> M;
    getline(cin, temp);
    vector<vector<int> > vec(N, vector<int>(M));
    vector<vector<char> > ans(N, vector<char>(M));
    for(int i = 0; i < N; i++){
        getline(cin, temp);
        for(int j = 0; j < M; j++){
            if(temp[j] == ' ')
                vec[i][j] = 0;
            else if(temp[j] == '+'){
                vec[i][j] = 1;
                startpos = {i, j};
            }
            else
                vec[i][j] = -1;
        }
    }

    endpos = bfs(vec, ans, startpos);
    if(endpos.x == -1){
        cout << -1 << '\n';
        return 0;
    }
    if(startpos == endpos){
        cout << 0 << '\n';
        return 0;
    }
    string out = "";
    cout << vec[endpos.y][endpos.x] - 1 << '\n';
    while(!(startpos == endpos)){
        out += ans[endpos.y][endpos.x];
        if(ans[endpos.y][endpos.x] == 'n'){
            endpos.y++;
        }
        if(ans[endpos.y][endpos.x] == 's'){
            endpos.y--;
        }
        if(ans[endpos.y][endpos.x] == 'e'){
            endpos.x--;
        }
        if(ans[endpos.y][endpos.x] == 'w'){
            endpos.x++;
        }
    }
    for(int i = out.size() - 1; i >= 0; i--)
        cout << out[i];
    cout << '\n';
    return 0;
}
