/* GCC */
#include <bits/stdc++.h>

using namespace std;
#define bs 10000000
#define big vector<long long>
void show(big a)
{

    cout << a.back();
    for(int i = (int)a.size() - 2; i >= 0; i--)
        printf("%07d", a[i]);
    printf("\n");
}
inline big operator+(big a, long long c)
{
    big b(1, c);
    long long car = 0;
    for(int i=0; i<a.size()|| car; i++)
    {
        if(i == a.size())
            a.push_back(0);
        a[i] = car + ( i < b.size() ? b[i] : 0);
        car =a[i] / bs;
        a[i] %= bs;
    }
    for(;a.size() > 1 && a.back() == 0; a.pop_back());
    return a;
}
inline big operator*(big a, long long b)
{

    long long car = 0;
    for(int i=0; i<a.size()|| car; i++)
    {
        if(i == a.size())
            a.push_back(0);
        long long cur = car + a[i] * b;
        car  = cur / bs;
        a[i] = cur % bs;
    }
    for(;a.size() > 1 && a.back() == 0; a.pop_back());
    return a;
}
long long gcd(long long a, long long b)
{
    return (b == 0) ? a : gcd(b, a % b);
}
int main()
{
    freopen("common.in", "r", stdin);
    freopen("common.out", "w", stdout);
    long long frst;
    bool flag = 0;
    int n;
    cin >> n;
    vector<pair<long long, long long> > prog(n);
    for(int i=0; i < n; i++)
    {

        cin >> prog[i].first >> prog[i].second;
        if(prog[i].second == 0)
        {
            flag = 1;
            frst = prog[i].first;
        }
    }
    if(flag)
    {
        for(int i = 0; i < n; i++)
            if(prog[i].second == 0)
                flag = (frst == prog[i].first);
            else
                flag = (frst >= prog[i].first && (frst - prog[i].first) % prog[i].second == 0);
        if(flag)
            cout<<frst<<'\n';
        else
            cout<<"0\n";
    }
    else
    {
        vector<long long> a, c, d, k;
        a = c = d = k = vector<long long>(n);
        sort(prog.begin(), prog.end());
        for(int i=0; i < prog.size(); i++)
        {
            a[i] = prog[prog.size() - 1 - i].first;
            d[i] = prog[prog.size() - 1 - i].second;
        }
        c[0] = d[0];
        k[n - 1] = 0;
        for(int cur = 0; cur < n - 1; cur++)
        {
            int nxt = cur + 1;
            c[nxt] = d[nxt];
            for(int i = cur; i >= 0; i--)
                c[nxt] /= gcd(c[nxt], d[i]);
            long long curM = 0, curD = d[nxt] / c[nxt];
            for(int i = cur - 1; i >= 0; i--)
                curM = (c[i] * (curM + k[i])) % curD;
            curM = (curM + a[0] - a[nxt]) % curD;
            if(curM)
                return cout<<"0\n", 0;
            curM = 0;
            curD = c[cur];
            for(int i = cur - 1; i >= 0; i--)
                {
                    curM = (c[i] * (curM + k[i])) % d[nxt];
                    curD = (curD * c[i]) % d[nxt];
                }
            curM = (curM + a[0] - a[nxt]) % d[nxt];
            k[cur] = 0;
            while(curM)
            {
                k[cur]++;
                curM = (curM + curD) % d[nxt];
            }
        }
        big ans(1, 0);
        for(int i = c.size() - 1; i >= 0; i--)
            ans = (ans + k[i]) * c[i];
        ans = ans + a[0];
        show(ans);
    }
    return 0;
}
