/*GCC*/
#include <bits/stdc++.h>

using namespace std;

typedef vector<long long> big;
typedef pair<long,long> pll;
#define a first
#define d second

const long long mod = 1000000000;

inline void die(long long a){
    cout << a << '\n';
    exit(0);
}

big operator+(big a,long long b){
    long long cur = b;
    for(long i = 0;cur;i++){
        if(i == a.size())a.push_back(0);
        cur += a[i];
        a[i] = cur % mod;
        cur /= mod;
    }
    while(a.size() > 1 && a.back() == 0)a.pop_back();
    return a;
}

big operator*(big a,long long b){
    long long cur = 0;
    for(long i = 0;i < a.size() || cur;i++){
        if(i == a.size())a.push_back(0);
        cur += a[i] * b;
        a[i] = cur % mod;
        cur /= mod;
    }
    while(a.size() > 1 && a.back() == 0)a.pop_back();
    return a;
}

vector<pll>p;
vector<long>c,k;
map<long,long>cnt;
long A,n;
bool d0 = 0;

void mrg(long j){
    c[j] = 1;
    long td = p[j].d;
    for(long i = 2;i * i <= td;i++){
        if(td % i != 0)continue;
        long t = 0;
        while(td % i == 0){
            t++;
            td /= i;
        }
        for(long k = 0;k < t - min(cnt[i],t);k++)
            c[j] *= i;
        cnt[i] = max(cnt[i],t);
    }
    if(td > 1){
        long t = 1;
        for(long i = 0;i < t - min(cnt[td],t);i++)
            c[j] *= td;
        cnt[td] = max(cnt[td],t);
    }
    long tempa = 0,tempd = 1;
    for(long i = j;i >= 0;i--)
        tempa = (tempa * c[i] % p[j+1].d + k[i]) % p[j+1].d;
    for(long i = 0;i <= j;i++)
        tempd = tempd * c[i] % p[j+1].d;
    long g = __gcd(tempd,p[j+1].d);
    if(tempa % g != p[j+1].a % g)
        die(0);
    k[j+1] = 0;
    while((tempa + k[j+1] * tempd % p[j+1].d) % p[j+1].d != p[j+1].a % p[j+1].d)
        k[j+1]++;
}



int main()
{
    freopen("common.in","r",stdin);
    freopen("common.out","w",stdout);
    cin >> n;
    p.resize(n);
    c.resize(n);
    k.resize(n);
    for(long i = 0;i < n;i++){
        scanf("%d%d",&p[i].a,&p[i].d);
        if(p[i].d == 0){
            d0 = 1;
            A = p[i].a;
        }
    }
    if(d0){
        for(long i = 0;i < n;i++){
            if(p[i].d == 0 && p[i].a != A)die(0);
            if(p[i].d > 0 && (p[i].a > A || (A - p[i].a) % p[i].d != 0))die(0);
        }
        die(A);
    }
    sort(p.begin(),p.end());
    reverse(p.begin(),p.end());
    k[0] = p[0].a;
    for(long i = 0;i < n - 1;i++)
        mrg(i);
    big ans(1,0);
    for(long i = n-1;i >= 0;i--)
        ans = ans * c[i] + k[i];
    printf("%ld",ans.back());
    for(long i = ans.size() - 2;i >= 0;i--)
        printf("%09ld",ans[i]);
    cout << '\n';
    return 0;
}
