/* GCC */
#include <bits/stdc++.h>
using namespace std;
int n;
typedef long long ll;

struct progress
{
    ll first;
    ll step;
};

ll Deoph(ll a, ll b, ll& x, ll& y)
{
    if(!a)
    {
        x = 0;
        y = 1;
        return b;
    }

    ll x1, y1;
    ll d = Deoph(b % a, a, x1, y1);
    y = x1;
    x = y1 - (b / a) * x1;
    return d;
}

progress sub(progress a, progress b)
{
    if(a.step == b.step && a.step == 0)
    {
        if(a.first == b.first)
            return a;
        return {-1, 0};
    }
    if(a.step == 0)
    {

        if(a.first >= b.first && (a.first - b.first) % b.step == 0)
            return {a.first, 0};
        return {-1, 0};
    }
    if(b.step == 0)
    {
        if(b.first >= a.first && (b.first - a.first) % a.step == 0)
            return {b.first, 0};
        return {-1, 0};
    }

    progress c;
    if(a.first < b.first)
        swap(a, b);
    ll x, y;
    ll g = Deoph(a.step, b.step, x, y);
    c.step = (a.step * b.step) / g;
    if((a.first - b.first) % g != 0)
        return {-1, 0};
    y *= (a.first - b.first) / g;
    ll d = abs(y) / (a.step / g);

    if(y > 0)
    {
        y-= d * (a.step / g);
        if(y == 0)
            y+= (a.step / g);
    }
    else
    {
        y+= d * (a.step / g);
        if(y <= 0)
            y+= (a.step / g);
    }

    c.first = b.step * y + b.first;
    return c;
}

int main()
{
    freopen("common.in", "r", stdin);
    freopen("common.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>> n;
    if(n == 0)
    {
        cout<< 0 << "\n";
        return 0;
    }
    vector<progress> v(n);

    for(int i = 0; i < n; i++)
        cin>> v[i].first >> v[i].step;

    for(int i = 1; i < n; i++)
    {
        v[0] = sub(v[0], v[i]);
        if(v[0].first == -1)
        {
            cout<< 0 << "\n";
            return 0;
        }
    }

    cout<< v[0].first << "\n";

    return 0;
}
